/*
 * Copyright
 *   2008 axYus - www.axyus.com
 *   2008 C.Bosquet - charles.bosquet@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.dgfip.xemelios.web.gwt.client.service;

import com.google.gwt.user.client.rpc.AsyncCallback;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.ConfigExportDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.ListResultatDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.SearchParameterDTO;
import java.util.List;
import java.util.Map;

/**
 * @author CBO
 */
public interface XemeliosServiceAsync {

    public void initSearchWindow(String documentId, String etatId, String elementId, AsyncCallback asyncCallback);

    public void destroySearchSession(String searchSessionId, AsyncCallback asyncCallback);

    public void getBudgets(String searchSessionId, String collectiviteId, AsyncCallback asyncCallback);

    public void getCritereItems(String searchSessionId, String collectiviteId, String budgetId, String criteriaId, String pluginId, AsyncCallback asyncCallback);

    public void getUpdatedSelectOneCritereItemDTO(String searchSessionId, String collectiviteId, String budgetId, String critereId, String selectId, Map<String, String>inputValuesById, String pluginId, AsyncCallback asyncCallback);

    public void search(String searchSessionId, String collectiviteId, String budgetId, List<SearchParameterDTO> searchParams, String pluginId, AsyncCallback asyncCallback);

    public void loadPage(String searchSessionId, int pageNumber, AsyncCallback asyncCallback);

    public void getStoredSearchs(String searchSessionId, AsyncCallback asyncCallback);

    public void getSavedPrivateSearchs(String searchSessionId, AsyncCallback asyncCallback);

    public void getSearchInitParameters(String searchSessionId, String storedSearchId, AsyncCallback asyncCallback);

    public void isPjAvailable(String collectivite, String pjNom, AsyncCallback asyncCallback);

    public void saveRequest(String searchSessionId, List<SearchParameterDTO> searchParams, String requestName, AsyncCallback asyncCallback);

    public void saveRequest(String searchSessionId, List<SearchParameterDTO> searchParams, String requestName, String requestId, AsyncCallback asyncCallback);

    public void getSearchInitParametersForSavedSearch(String searchSessionId, String searchId, AsyncCallback asyncCallback);

    public void processPluginExport(String searchSessionId, String collectiviteId, String budgetId, String pluginId, List<SearchParameterDTO> searchParams, AsyncCallback asyncCallback);

    public void getListResultatDTO(String searchSessionId, AsyncCallback asyncCallback);

    public void setListResultatDTO(String searchSessionId, ListResultatDTO lr, AsyncCallback asyncCallback);

    public void getDistinctValues(String searchSessionId, String collectivite, String budget, String path, AsyncCallback asyncCallback);

    public void getDocuments(AsyncCallback asyncCallback);

    public void getListeConfigExport(String docId, String etatId, AsyncCallback asyncCallback);

    public void getExportModel(String docId, String etatId, String id, AsyncCallback asyncCallback);

    public void saveExportModel(ConfigExportDTO config, AsyncCallback asyncCallback);

    public void deleteExportModel(String docId, String etatId, String id, AsyncCallback asyncCallback);

    public void createExportModel(String docId, String etatId, AsyncCallback asyncCallback);

    public void getSearchSessionInformations(String searchSessionId, AsyncCallback asyncCallback);

    public void createExportRequest(String searchSessionId, String exportConfigId, String fileName, String exportName, AsyncCallback<String> asyncCallback);
}
